await Promise.resolve(1)
  .then(
    n => n * 2
  )
  .then(
    n => n * n
  );

var a = 1
var b = (n => n * 2)(a)
var c = (n => n * n)(b) ;

var a = await Promise.resolve(1)
var b = (n => n * 2)(a)
var c = (n => n * n)(b);

var a = Promise.resolve(1)
var b = a.then( n => n *2 )
var c = b.then( n => n * n)

await c;

//recall
a = 1
var b = (n => n * 2)(a);

var async = (fn) => (target) => target.then(fn);

//recalll
var a = Promise.resolve(1)
var b = a.then( n => n *2 )
var c = b.then( n => n * n)

await c;

var a = Promise.resolve(1)
var b = async( n => n * 2)(a)
var c = async( n => n * n)(b)

await c;

var async = (fn) => (target) => target.then(fn);

var _ = require('lodash')
var merge = _.spread(_.merge)
var equal = require('ramda').equals

var getGeoExifSync = function(filepath){
    return { 
      latitude: '123.45676', longitude: '65.123454'
    }
}

var geoLookUpSync = function(latlon){
    return {
        street: '123 hello street',
        country: 'Spaghetti Land'
    }
}

var getGeoExifAsync = function(filepath){
  return Promise.resolve({ 
      latitude: '123.45676', longitude: '65.123454'
  })
}
                         
var geoLookUpAsync = function(latlon){
    return Promise.resolve({
        street: '123 hello street',
        country: 'Spaghetti Land'
    })
}
               
var getGeoSync = function(filepath){
    var latlon = getGeoExifSync(filepath)
    
    var address = geoLookUpSync(latlon)
    
    var geo = merge([latlon, address])
    
    return geo
}

var getGeoAsync = function(filepath){
	var latlon = getGeoExifAsync(filepath)

	var address = async(geoLookUpAsync)(latlon)

	var geos = Promise.all([latlon, address])

	var geo = async(merge)(geos)

	return geo
}

var getGeoAwait = async function (filepath){
    var latlon = getGeoExifAsync(filepath)

	var address = await geoLookUpAsync(latlon)

	var geos = await Promise.all([latlon, address])

	var geo = merge(geos)

	return geo
}

var results = [getGeoSync, getGeoAsync, getGeoAwait].map(
    (func) => func('c:\\file.jpg')
)

await Promise.all(results)
                                          ;
